import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'colors.dart';
import 'sizes.dart';

class Styles {
  static ThemeData themeDefault(
      Color? primaryLightColor,
      Color? primarySecondColor,
      Color? primaryDarkColor,
      Color? background,
      TextTheme? textTheme) {
    return ThemeData(
        textTheme: textTheme,
        primaryColor: primaryLightColor,
        primaryColorLight: primaryLightColor,
        primaryColorDark: primaryDarkColor,
        buttonColor: primarySecondColor,
        iconTheme: IconThemeData(color: AppColors.white),
        canvasColor: background,
        scaffoldBackgroundColor: background,
        highlightColor: Colors.transparent,
        focusColor: primaryLightColor);
  }

  static TextStyle customTextSmallStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.w400,
        fontSize: Sizes.TEXT_SIZE_12,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextSmallBoldStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.bold,
        fontSize: Sizes.TEXT_SIZE_12,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextSmallItalictStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(
      fontName ?? "Open Sans",
      fontSize: Sizes.TEXT_SIZE_12,
      color: color,
      fontWeight: FontWeight.normal,
      fontStyle: FontStyle.italic,
    );
  }

  static TextStyle customTextDefaultStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.w400,
        fontSize: Sizes.TEXT_SIZE_14,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextDefaultBoldStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.bold,
        fontSize: Sizes.TEXT_SIZE_14,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextDefaultItalictStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(
      fontName ?? "Open Sans",
      fontSize: Sizes.TEXT_SIZE_14,
      color: color,
      fontWeight: FontWeight.normal,
      fontStyle: FontStyle.italic,
    );
  }

  static TextStyle? customTextMediumStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.w500,
        fontSize: Sizes.TEXT_SIZE_16,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextMediumItalicStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.normal,
        fontSize: Sizes.TEXT_SIZE_16,
        fontStyle: FontStyle.italic);
  }

  static TextStyle customTextMediumBoldStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.bold,
        fontSize: Sizes.TEXT_SIZE_16,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextLargeStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.w500,
        fontSize: Sizes.TEXT_SIZE_18,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextLargeItalicStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.normal,
        fontSize: Sizes.TEXT_SIZE_18,
        fontStyle: FontStyle.italic);
  }

  static TextStyle customTextLargeBoldStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.bold,
        fontSize: Sizes.TEXT_SIZE_18,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextHeaderDefaultStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.bold,
        fontSize: Sizes.TEXT_SIZE_20,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextHeaderMediumStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.bold,
        fontSize: Sizes.TEXT_SIZE_22,
        fontStyle: FontStyle.normal);
  }

  static TextStyle customTextHeaderLargeStyle(
      {Color? color = AppColors.textColor, String? fontName}) {
    return GoogleFonts.getFont(fontName ?? "Open Sans",
        color: color,
        fontWeight: FontWeight.bold,
        fontSize: Sizes.TEXT_SIZE_26,
        fontStyle: FontStyle.normal);
  }
}
