import 'package:flutter_bounceable/flutter_bounceable.dart';

import '../../common/values/colors.dart';
import '../../common/values/sizes.dart';
import '../spaces.dart';
import 'package:easy_localization/src/public_ext.dart';
import 'package:flutter/material.dart';

import '../text/custom_text_medium_italic_field.dart';

class CartEmptyUIPageWidget extends StatelessWidget {
  final Function? navigationHome;
  final String? imagePath;

  const CartEmptyUIPageWidget({Key? key, this.navigationHome, this.imagePath})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      color: AppColors.backgroundWhiteColor,
      height: Sizes.height(context) / 2,
      alignment: Alignment.center,
      child: Column(
        mainAxisSize: MainAxisSize.max,
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Bounceable(
            onTap: () => navigationHome,
            child: Image.asset(imagePath ?? "assets/images/ic_add_cart.png",
                height: Sizes.WIDTH_64, width: Sizes.WIDTH_64),
          ),
          SpaceH10(),
          CustomTextMediumItalicField(
            label: "text_cart_empty".tr(),
            color: AppColors.textColor1,
          )
        ],
      ),
    );
  }
}
