
import 'package:flutter/material.dart';

import '../../common/values/styles.dart';

class CustomTextHeaderLargeField extends StatelessWidget {
  final label;
  final color;
  final TextAlign? align;
  final int? maxLine;
  final String? fontName;

  CustomTextHeaderLargeField(
      {required this.label,
      this.color,
      this.align,
      this.maxLine,
      this.fontName});

  @override
  Widget build(BuildContext context) {
    if (label != null && label != "") {
      return Text(label!,
          style: Styles.customTextHeaderLargeStyle(
              fontName: fontName, color: color),
          textAlign: align,
          maxLines: maxLine ?? 2,
          overflow: TextOverflow.ellipsis);
    } else {
      return Container();
    }
  }
}
