import 'package:flutter/material.dart';

import '../../common/values/styles.dart';

class CustomTextSmallBoldField extends StatelessWidget {
  final label;
  final color;
  final TextAlign? align;
  final int? maxLine;
  final String? fontName;

  CustomTextSmallBoldField(
      {required this.label, this.color, this.align, this.maxLine, this.fontName});

  @override
  Widget build(BuildContext context) {
    if (label != null && label != "") {
      return Text(label!,
          style: Styles.customTextSmallBoldStyle(
              fontName: fontName, color: color),
          textAlign: align,
          maxLines: maxLine ?? 2,
          overflow: TextOverflow.ellipsis);
    } else {
      return Container();
    }
  }
}
